package net.ko.bean;

import java.util.logging.Level;

import net.ko.framework.Ko;
import net.ko.kobject.KObject;
import net.ko.utils.KString;


@SuppressWarnings("serial")
public class KClass extends KObject {
	private transient Class<KObject> clazz;
	private transient String caption;
	private transient String categorie;
	private transient String simpleName;
	public KClass(){
		super();
		keyFields="id";
		caption="";
	}
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public KClass(Class clazz) {
		this();
		this.clazz=clazz;
		id=clazz.getName();
		simpleName=clazz.getSimpleName();
		caption=getPluriel();
		categorie="";
	}
	public String getTableName(){
		String result="";
		if(clazz!=null)
			try {
				result=clazz.newInstance().getTableName();
			} catch (InstantiationException | IllegalAccessException e) {
				Ko.klogger().log(Level.WARNING, "Impossible d'instancier : "+clazz, e);
			}
		return result;
	}
	@Override
	public String toString() {
		return getCaption();
	}
	public String getCaption() {
		String result=caption;
		if("".equals(result))
				result=simpleName;
		return result;
	}
	public void setCaption(String caption) {
		this.caption = caption;
	}
	public String getCategorie() {
		return categorie;
	}
	public void setCategorie(String categorie) {
		this.categorie = categorie;
	}
	public String getSimpleName() {
		return simpleName;
	}
	public void setSimpleName(String simpleName) {
		this.simpleName = simpleName;
	}
	public String getPluriel(){
		String result=simpleName.replaceFirst("K(.*)", "$1");
		result=KString.capitalizeFirstLetter(result);
		result=KString.pluriel(result);
		return result;
	}
	public Class<KObject> getClazz() {
		return clazz;
	}
}
