package net.ko.http.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.logging.Level;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.ko.bean.KClass;
import net.ko.bean.KTester;
import net.ko.cache.KCache;
import net.ko.cache.KCacheType;
import net.ko.framework.Ko;
import net.ko.framework.KoHttp;
import net.ko.http.objects.KRequest;
import net.ko.http.views.KHtmlFieldControl;
import net.ko.http.views.KHttpForm;
import net.ko.kobject.KListObject;
import net.ko.kobject.KObject;
import net.ko.types.HtmlControlType;
import net.ko.utils.KPackageUtils;

/**
 * Servlet implementation class KSlistClasses
 */
@WebServlet(name="KSlistClasses", urlPatterns = { "/listClasses.frm","/classes.main" })
public class KSlistClasses extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private String cls=null;
	private String depth="2";
	private boolean useCache=false;
	private String field="";
	private boolean isAjax=false;

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doGet(req, resp);
	}

	@Override
	public void init() throws ServletException {
		// TODO Auto-generated method stub
		super.init();
	}
    /**
     * @see HttpServlet#HttpServlet()
     */
    public KSlistClasses() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		KoHttp.kstart(request.getSession());
		response.setCharacterEncoding("UTF-8");
		response.setContentType("text/html");
		PrintWriter out=response.getWriter();
		cls=KRequest.GETPOST("cls", request);
		depth=KRequest.GETPOST("depth", request,"1");
		useCache=KRequest.GETPOST("useCache", request, false);
		field=KRequest.GETPOSTValues("field", request, "");
		isAjax=KRequest.keyExists("_ajx", request);
		String pageFooter=getPageFooter(request, response);
		out.print(getPageHeader(request, response));
		try{
			getListClasses(request, response);
			out.print("<div id=\"_ajx\"></div>");
			out.print("<div id=\"_ajxContent\">");
			out.flush();
			KRequest.include("ajaxPageList.frm", request, response, "_ajx&cls="+cls+"&depth="+depth+"&useCache="+useCache+"&field="+field);
			out.print("</div>");
		}
		catch(Exception e){
			Ko.klogger().log(Level.WARNING, "Erreur de chargement", e);
		};
		out.print(pageFooter);
	}
	private void getListClasses(HttpServletRequest request, HttpServletResponse response) throws IOException, ClassNotFoundException, SecurityException, IllegalArgumentException, NoSuchFieldException, IllegalAccessException, InstantiationException, SQLException{
		PrintWriter out=response.getWriter();
		out.print("<div id=\"_classes\">");
		out.print("<form method=\"post\" name=\"_frmClasse\" action=\""+request.getRequestURI()+"\">");
		out.print("<fieldset id=\"_fsClasses\">");
		out.print("<legend onclick=\"javascript:Forms.Utils.toogleText($('toogle'),'_innerFs');\">Classes&nbsp;<div class=\"arrow-up\" id=\"toogle\"></div>&nbsp;</legend>");
		out.print("<div id=\"_innerFs\">");

		if(useCache){
			Ko.cacheType=KCacheType.ktListAndObjects;
			KCache.loadAllCache();
		}
		try{
			Ko.ConstraintsDepth=Integer.valueOf(depth);}
		catch(Exception e){Ko.ConstraintsDepth=1;depth="1";}
		KListObject<KClass> kclasses= KPackageUtils.getKClasses(Ko.kpackage());

		if(cls==null)
			if(kclasses.count()>0)
				cls=kclasses.get(0).getId()+"";
		KTester tester=new KTester();
		tester.setCls(cls);
		KHttpForm frmTester= new KHttpForm(tester,request);
		frmTester.setResponse(response,false);
		frmTester.load(true);
		KHtmlFieldControl listCls=(KHtmlFieldControl)frmTester.getFieldControl("cls");
		if(listCls!=null){
			listCls.setListObject(kclasses);
			listCls.setCaption("Classe :");
			listCls.setOptions("onchange='javascript:_frmClasse.submit();'");
		}
		KHtmlFieldControl cDepth=(KHtmlFieldControl)frmTester.getFieldControl("depth");
		if(cDepth!=null){
			cDepth.setCaption("Ko.constraintDepth :");
		}
		KHtmlFieldControl listFields=(KHtmlFieldControl)frmTester.getFieldControl("field");
		if(listFields!=null){
			listFields.setCaption("Membres");
			listFields.setListObject(tester.getListFields());
			listFields.setFieldType(HtmlControlType.khcCheckedList);
		}
		frmTester.swapFcPos("depth", "useCache");
		frmTester.getFieldControl("useCache").setCaption("Activation du cache");
		frmTester.addHTML("<div class=''><input type='button' class='sBtn' value='Appliquer' onclick='javascript:_frmClasse.submit();'></div>");
		out.print(frmTester);
		out.print("</div>");
		out.print("</fieldset>");
		//out.print("</form>");
		out.print("</div>");
		out.print("<div id='_commandes'>");
		out.print("<form id=\"_frmCommandes\" name=\"_frmCommandes\">");
		out.print("<fieldset id=\"_fsCommandes\">");
		out.print("<legend onclick=\"javascript:Forms.Utils.toogleText($('toogleCmd'),'_innerFsCmd');\">Redémarrage&nbsp;<div class=\"arrow-up\" id=\"toogleCmd\"></div>&nbsp;</legend>");
		out.print("<div id=\"_innerFsCmd\">");
		KHtmlFieldControl khfc=new KHtmlFieldControl("Options de redémarrage", "", "restart", "restart", HtmlControlType.khcCheckedList, "{Connexion BDD,Validation (kox.xml),Mappings (mox.xml),Messages et ER, Css variables}", "");
		out.print(khfc);
		out.print("<input type='button' value=\"Redémarrer l'application\" class='sBtn' onclick='$postForm(\"_frmCommandes\",\"_commandesResponse\",\"restart.cmd\")'><div id='_commandesResponse'></div></form></div></div>");
	}
	public String getPageFooter(HttpServletRequest request,HttpServletResponse response) {
		String result="";
		if(!isAjax){
				if(!"".equals(Ko.kFooterURL()))
					result=KRequest.includeResponse(Ko.kFooterURL(), request, response) ;
		}
		return result;
	}
	public String getPageHeader(HttpServletRequest request,HttpServletResponse response) {
		String result="";
		if(!isAjax){
				if(!"".equals(Ko.kHeaderURL()))
					result=KRequest.includeResponse(Ko.kHeaderURL(), request, response) ;
		}
		return result;
	}
}
