package net.ko.http.views;

import java.sql.SQLException;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.ko.controller.KObjectController;
import net.ko.controller.KObjectFieldController;
import net.ko.displays.KObjectDisplay;
import net.ko.framework.Ko;
import net.ko.framework.KoHttp;
import net.ko.kobject.KObject;
import net.ko.types.HtmlControlType;

public class KHttpShow extends KobjectHttpAbstractForm {

	private String fieldSetLegend;
	private int fieldSets;
	
	public KHttpShow(KObject ko, HttpServletRequest request) {
		super(ko, request);
	}
	@Override
	public void init() {
		
	}
	public String getFormContent(){
		return fieldControls.toString();
	}
	/* (non-Javadoc)
	 * @see net.ko.http.views.KobjectHttpAbstractView#load()
	 */
	@Override
	public boolean load() throws SecurityException, IllegalArgumentException,
			SQLException, NoSuchFieldException, IllegalAccessException, InstantiationException, ClassNotFoundException {
		return load(false);
	}
	@Override
	public boolean load(boolean noDb) throws SecurityException, IllegalArgumentException, NoSuchFieldException, IllegalAccessException, InstantiationException, ClassNotFoundException, SQLException{
		boolean result= super.load(noDb || insertMode);
		initFieldControls();
		return result;
	}
	public void getDefaultComplete(String redirect,HttpServletResponse response) throws SecurityException, IllegalArgumentException, NoSuchFieldException, IllegalAccessException, InstantiationException, ClassNotFoundException, SQLException{
		this.load(false);
		addDefaultFieldSet().setPos(-30);
		closeDefaultFieldSet();
	}
	private void initFieldControls() {
		setLoaded(true);
		KObjectController koc=null;
		koc=Ko.kcontroller().getObjectController(ko.getClass().getSimpleName());
		KObjectDisplay display= getDisplayInstance();
		fieldSetLegend=display.getFormCaption(ko.getClass(),koc);
		ko.refresh();
		for(Map.Entry<String,KObjectFieldController> e:koc.getMembers().entrySet()){
			String field=e.getKey();
			KFieldControl bestCtrl=display.getReadOnlyControl(ko, field, koc, request);
			bestCtrl.setReadOnly(true);
			((KHtmlFieldControl) bestCtrl).setOwner(this);
			fieldControls.put(field, bestCtrl);
		}
		
	}
	
	private KFieldControl fieldSet(String legend) {
		return fieldSet(legend, "");
	}
	private KFieldControl fieldSet(String legend,String options){
		return new KHtmlFieldControl(legend, "", "", "_fieldset", HtmlControlType.khcFieldSet, null, options);
	}
	private KFieldControl getDefaultFieldSet(){
		if(fieldSetLegend==null || "".equals(fieldSetLegend))
			return this.fieldSet(this.ko.getClass().getSimpleName());
		else
			return this.fieldSet(fieldSetLegend);
	}
	
	/**
	 * @return le fieldset HTML ayant pour legend le nom de la classe de l'objet
	 */
	public KFieldControl addDefaultFieldSet(){
		KFieldControl result=fieldControls.put("_fieldset",getDefaultFieldSet());
		fieldSets++;
		return result;
	}
	
	public KFieldControl closeDefaultFieldSet(){
		KHtmlFieldControl cfs=new KHtmlFieldControl();
		cfs.setFieldType(HtmlControlType.khcCustom);
		cfs.setValue("</fieldset>");
		KFieldControl result=fieldControls.put("/_fieldset",cfs);
		fieldSets--;
		return result;
	}
	
	@Override
	public String toString() {
		String ret=getFormContent();
		if(ajaxIncludes)
			ret+=KoHttp.kajaxIncludes(request);
		return getPageHeader()+ret+getPageFooter();
	}

}
