package net.ko.http.views;

import java.util.Map;
import java.util.Map.Entry;

import net.ko.kobject.KMask;
import net.ko.utils.KStrings;

public class KListTemplateParser extends KTemplateParser {
	protected KMask mask;
	protected boolean maskModified=false;
	public KListTemplateParser(String strTemplate) {
		super(strTemplate);
		mask=new KMask();
	}
	protected void updateListColumn(String fieldName,Map<String,Object> values) throws SecurityException, IllegalArgumentException, NoSuchFieldException, IllegalAccessException{
		for(Map.Entry<String, Object> e:values.entrySet())
			view.invoke(e.getKey(), view.getClass(), new Object[]{fieldName,e.getValue()});
	}
	@Override
	protected String getOperation(Entry<String, Object> e) {
		String result=super.getOperation(e);
		String key=e.getKey();
		String value=(String)e.getValue();
		if(key.equalsIgnoreCase("mask")){
			addMask(value);
			result="";
		}
		return result;
	}
	@Override
	public String getValue(String jsonFieldName) {
		String result="";
		KStrings strings=new KStrings(jsonFieldName);
		if(!strings.containsKey("0")){
			for(Map.Entry<String, Object> e:strings.getStrings().entrySet()){
				String key=e.getKey();
				String value=(String)e.getValue();
				if(strings.containsKey("name")){
					try {
						updateListColumn((String)strings.get("name"), strings.getStrings());
					} catch (SecurityException | IllegalArgumentException
							| NoSuchFieldException | IllegalAccessException e1) {
					}
				}
			}
		}else
			result="{"+jsonFieldName+"}";
		return result;
	}
	public void addMask(String jsonField){
		mask.addMask(jsonField);
		maskModified=true;
	}

	@Override
	public void parse(KAbstractView view) {
		super.parse(view);
		KPageList pl=((KPageList)view);
		if(maskModified)
			pl.setInnerMask(mask);
		pl.fieldControls.clear();
		//resultString=decodeStrTemplate(resultString);
		pl.addHTML("content", resultString);
	}

}
