/**
 * Classe KConstraintBelongsTo
 * 
 * @author jcheron
 * @link http://www.kobject.net/
 * @copyright Copyright kobject 2008-2012
 * @license http://www.kobject.net/index.php?option=com_content&view=article&id=50&Itemid=2  BSD License
 * @version $Id: KConstraintBelongsTo.java,v 1.4 2011/01/21 01:22:52 jcheron Exp $
 * @package ko.kobject
 */
package net.ko.kobject;

import net.ko.ksql.KDataBase;

@SuppressWarnings("serial")
public class KConstraintBelongsTo extends KConstraint {

	public KConstraintBelongsTo(String member, Class<? extends KObject> clazz,
			String where) {
		super(member, clazz, where);
	}

	@Override
	public void load(KDataBase db,KDuoClasseList duoClasseList) {
		if (!duoClasseList.exists(getDuoClasse())){
			super.load(db,duoClasseList);
			try {
				owner.__setAttribute(member, KObject.kloadOneForConstraint(clazz, db, owner._constraintShowWithMask(where),duoClasseList));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	@Override
	public void load(KListObject<? extends KObject> kl) {
			super.load(kl);
			try {
				owner.__setAttribute(member, kl.selectFirst(owner._constraintShowWithMask(where.replace("'", ""))));
			} catch (Exception e) {
				e.printStackTrace();
			}
	}

	@Override
	public void save(KDataBase db) {
		try{
			KObject ko=(KObject) owner.__getAttribute(member);
			if (ko!=null) 
				ko.updateToDb(db);
		} catch (Exception e) {
			e.printStackTrace();
		}	
		
	}

	@Override
	public String getSql() throws InstantiationException,
			IllegalAccessException {
		return null;
	}

	@Override
	public void update() {
		try {
			KObject ko=(KObject)owner.getAttribute(member);
			if(ko!=null)
				owner.__setAttribute(getPkField(), ko.getFirstKeyValue());
		} catch (SecurityException | NoSuchFieldException
				| IllegalAccessException | IllegalArgumentException e) {}
	}

}
