/**
 * Classe KConstraintHasAndBelongsToMany
 * 
 * @author jcheron
 * @link http://www.kobject.net/
 * @copyright Copyright kobject 2008-2010
 * @license http://www.kobject.net/index.php?option=com_content&view=article&id=50&Itemid=2  BSD License
 * @version $Id: KConstraintHasAndBelongsToMany.java,v 1.4 2011/01/21 01:22:52 jcheron Exp $
 * @package ko.kobject
 */
package net.ko.kobject;

import net.ko.ksql.KDataBase;
import net.ko.ksql.KSqlQuery;
import net.ko.list.MapArrayString;
import net.ko.utils.KString;

public class KConstraintHasAndBelongsToMany extends KConstraint {
	private static final long serialVersionUID = 1L;
	private Class<? extends KObject> joinClass;
	private String fkWhere;

	public Class<? extends KObject> getJoinClass() {
		return joinClass;
	}
	public Class<? extends KObject> getClazzList() {
		return joinClass;
	}

	public void setJoinClass(Class<? extends KObject> joinClass) {
		this.joinClass = joinClass;
	}

	public KConstraintHasAndBelongsToMany(String member,
			Class<? extends KObject> clazz, String koWhere) {
		this(member, clazz, koWhere,"");
	}
	public KConstraintHasAndBelongsToMany(String member,
			Class<? extends KObject> clazz, String koWhere,String fkWhere) {
		super(member, clazz, koWhere);
		this.fkWhere=fkWhere;
		lazy=false;
	}
	private String getFkWhere(){
		String result=fkWhere;
		if("".equals(fkWhere)){
			try {
				String table=KSqlQuery.getTableName(clazz.newInstance().getTableName());
				result="id"+KString.capitalizeFirstLetter(table)+"="+table+".id";
				
			} catch (Exception e) {}
		}
		return result;
	}
	@Override
	public void load(KDataBase db,KDuoClasseList duoClasseList) {
		if (!duoClasseList.exists(getDuoClasse())){
			super.load(db,duoClasseList);
			try {
				owner.__setAttribute(member, KListObject.kloadForConstraint(clazz, db, getSql(),duoClasseList));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	@Override
	public void load(KListObject<? extends KObject> kl) {
			super.load(kl);
			try {
				KListObject<? extends KObject> joinKl=kl.select(owner._constraintShowWithMask(where.replace("'", "")));
				String memberJoinKl=KSqlQuery.getTableName(clazz.newInstance().getTableName());
				owner.__setAttribute(member, joinKl.getMemberAsKL(memberJoinKl, clazz));
			} catch (Exception e) {
				e.printStackTrace();
			}
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public void save(KDataBase db) {
		try{
			KListObject<? extends KObject> kl=(KListObject<? extends KObject>) owner.__getAttribute(member);
			if (kl!=null){
				String table=KString.capitalizeFirstLetter(KSqlQuery.getTableName(clazz.newInstance().getTableName()));
				fkWhere=getFkWhere();
				String koField=where.substring(0, where.indexOf("=")).trim();
				String fkField=fkWhere.substring(0,fkWhere.indexOf("=")).trim();
				koField=KString.getLastAfter(koField, ".");
				fkField=KString.getLastAfter(fkField, ".");
				KListObject<? extends KObject> relKl=new KListObject<KObject>((Class<KObject>) joinClass);
				for(KObject ko:kl){
					KObject relKo=joinClass.newInstance();
					relKo.setAttribute(fkField, ko.getFirstKeyValue());
					relKo.setAttribute(koField,owner.getFirstKeyValue());
					relKo.setRecordStatus(ko.recordStatus);
					relKl.add(relKo, true);
				}
				relKl.saveToDb(db);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}	
		
	}

	@Override
	public String getSql() throws InstantiationException,
			IllegalAccessException {
		String select=null;
		String table=KSqlQuery.getTableName(clazz.newInstance().getTableName());
		String joinTable=KSqlQuery.getTableName(joinClass.newInstance().getTableName());
		fkWhere=getFkWhere();
		String tWhere=where+" AND "+fkWhere;
		select="SELECT "+table+".* FROM `"+joinTable+"`,`"+table+"` WHERE "+owner._constraintShowWithMask(tWhere);
		return select;
	}
/*	public String getFkField(){
		String fkWhere=getFkWhere();
		String result="";
		result=fkWhere.substring(0,fkWhere.indexOf("=")).trim();
		return result;
	}*/
}
