/**
 * Classe KConstraintHasMany
 * 
 * @author jcheron
 * @link http://www.kobject.net/
 * @copyright Copyright kobject 2008-2010
 * @license http://www.kobject.net/index.php?option=com_content&view=article&id=50&Itemid=2  BSD License
 * @version $Id: KConstraintHasMany.java,v 1.4 2011/01/21 01:22:52 jcheron Exp $
 * @package ko.kobject
 */
package net.ko.kobject;

import net.ko.ksql.KDataBase;
import net.ko.ksql.KSqlQuery;

@SuppressWarnings("serial")
public class KConstraintHasMany extends KConstraint {

	public KConstraintHasMany(String member,Class<? extends KObject> clazz ,String where) {
		super(member,clazz,where);
		lazy=false;
	}

	@Override
	public void load(KDataBase db,KDuoClasseList duoClasseList) {
		if (!duoClasseList.exists(getDuoClasse())){
			super.load(db,duoClasseList);
			try {
				owner.__setAttribute(member, KListObject.kloadForConstraint(clazz, db, getSql(),duoClasseList));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	@Override
	public void load(KListObject<? extends KObject> kl) {
			super.load(kl);
			try {
				owner.__setAttribute(member, kl.select(owner._constraintShowWithMask(where.replace("'", ""))));
			} catch (Exception e) {
				e.printStackTrace();
			}
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public void save(KDataBase db) {
	try{
		KListObject<? extends KObject> kl=(KListObject<? extends KObject>) owner.__getAttribute(member);
		if (kl!=null) 
			kl.saveToDb(db);
	} catch (Exception e) {
		e.printStackTrace();
	}		
	}

	@Override
	public String getSql() throws InstantiationException, IllegalAccessException {
		String select=null;
		select=clazz.newInstance().getSql();
		select=KSqlQuery.addWhere(select, owner._constraintShowWithMask(where));
		return select;
	}

}
