/**
 * Classe KDBMysql
 * 
 * @author jcheron
 * @link http://www.kobject.net/
 * @copyright Copyright kobject 2008-2009
 * @license http://www.kobject.net/index.php?option=com_content&view=article&id=50&Itemid=2  BSD License
 * @version $Id: KDBMysql.java,v 1.4 2011/01/14 01:12:55 jcheron Exp $
 * @package ko.ksql
 */
package net.ko.ksql;

import java.sql.DriverManager;
import java.sql.SQLException;

public class KDBMysql extends KDataBase {

	@Override
	protected synchronized void _connect() throws ClassNotFoundException, SQLException {
		super._connect();
		Class.forName(driver);
		connection=DriverManager.getConnection(getURL(), params.getUser(), params.getPass());
	}
	public KDBMysql(String host, String user, String pass, String base) {
		this(host,user,pass,base,"3306");
	}
	public KDBMysql(String host, String user, String pass, String base,String port) {
		super(host, user, pass, base,port);
		driver="com.mysql.jdbc.Driver";
	}

	@Override
	public void connect(String host, String user, String pass, String base,
			String port, String options) throws ClassNotFoundException,
			SQLException {
		// TODO Auto-generated method stub
		super.connect(host, user, pass, base, port, options);
		driver="com.mysql.jdbc.Driver";		
	}
	public KDBMysql() {
		super();
		driver="com.mysql.jdbc.Driver";
		params.setPort("3306");
		options="jdbcCompliantTruncation=false";
	}
	@Override
	public String getURL() {
		String u="jdbc:mysql://"+params.getHost()+"/"+params.getBase();
		if(!params.getPort().equals(""))
			u="jdbc:mysql://"+params.getHost()+":"+params.getPort()+"/"+params.getBase();
		if(options!="")
			u+="?"+options;
		return u;
	}

}
