package net.ko.ksql;

import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

public class KDbField {
	private boolean index=false;
	private String name;
	private String type;
	private boolean primary=false;
	private boolean autoInc=false;
	private boolean allowNull=true;
	private String _default;
	private String typeValues;
	private int numericPrecision;
	private int numericScale;
	private int columnSize=-1;
	private String javaType;
	
	public String getJavaType() {
		return javaType;
	}
	public void setJavaType(String javaType) {
		this.javaType = javaType;
	}
	public boolean isIndex() {
		return index;
	}
	public String getName() {
		return name;
	}
	public String getType() {
		return type;
	}
	public boolean isPrimary() {
		return primary;
	}
	public boolean isAutoInc() {
		return autoInc;
	}
	public boolean isAllowNull() {
		return allowNull;
	}
	public String get_default() {
		return _default;
	}
	public String getTypeValues() {
		return typeValues;
	}
	public int getNumericPrecision() {
		return numericPrecision;
	}
	public int getNumericScale() {
		return numericScale;
	}
	public int getColumnSize() {
		return columnSize;
	}
	public KDbField(int columnIndex,ResultSetMetaData rsmd) throws SQLException{
		name=rsmd.getColumnName(columnIndex);
		type=rsmd.getColumnTypeName(columnIndex);
		columnSize=rsmd.getColumnDisplaySize(columnIndex);
		allowNull=rsmd.isNullable(columnIndex)==DatabaseMetaData.columnNullable;
		javaType=KDataTypeConverter.toJavaType(type,rsmd.getColumnClassName(columnIndex));
		autoInc=rsmd.isAutoIncrement(columnIndex);
	}
	public void setPrimary(boolean primary) {
		this.primary = primary;
	}
	public KDbField(ResultSet rs) throws SQLException{
		name=rs.getString("COLUMN_NAME");
		type=rs.getString("TYPE_NAME");
		columnSize= rs.getInt("COLUMN_SIZE");
		allowNull= rs.getInt("NULLABLE")==DatabaseMetaData.columnNullable;
		javaType=KDataTypeConverter.toJavaType(type);
	}
	public void setAutoInc(boolean autoInc) {
		this.autoInc = autoInc;
	}
	public String toString(){
		return javaType;
	}
}
