package net.ko.list;

import java.util.HashMap;
import java.util.Iterator;

public class MapArrayString<K extends Object> implements Iterable<K>{
	private HashMap<K, String> map;
	private String separator;
	private boolean unique;
	
	public MapArrayString() {
		separator=";";
		unique=true;
		map=new HashMap<>();
	}
	
	public void put(K key,String value){
		if(map.containsKey(key)){
			String v=separator+ map.get(key)+separator;
			if(unique && v.contains(separator+value+separator))
				return;
			map.put(key, map.get(key)+separator+value);
		}
		else
			map.put(key, value);
	}

	public String getSeparator() {
		return separator;
	}

	public void setSeparator(String separator) {
		this.separator = separator;
	}

	public HashMap<K, String> getMap() {
		return map;
	}
	
	public String get(K key){
		return map.get(key);
	}

	@Override
	public Iterator<K> iterator() {
		return map.keySet().iterator();
	}

	public boolean isUnique() {
		return unique;
	}

	public void setUnique(boolean unique) {
		this.unique = unique;
	}
	
}
