package net.ko.mapping;

import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxEvent extends KAjaxObject {
	protected String triggerId;
	protected String triggerEvent;

	public KAjaxEvent() {
	}
	public KAjaxEvent(String triggerId,String triggerEvent){
		this();
		this.triggerId=triggerId;
		setTriggerEvent(triggerEvent);
	}
	@Override
	public String createFunction() {
		return "Forms.Utils.fireEvent($('"+triggerId+"'), '"+triggerEvent+"');";
	}

	@Override
	public boolean isValid() {
		return KString.isNotNull(triggerId);
	}
	protected void setTriggerEvent(String triggerEvent) {
		if(KString.isNull(triggerEvent))
			triggerEvent="click";
		if(triggerEvent.startsWith("on"))
			triggerEvent=triggerEvent.substring(2);
		triggerEvent=triggerEvent.toLowerCase();
		this.triggerEvent = triggerEvent;
	}
	@Override
	public void initFromXml(Node item) {
		Element e=(Element)item;
		setTriggerEvent(e.getAttribute("triggerEvent"));
		String triggerId=e.getAttribute("triggerId");
		if(triggerId!=null&&!"".equals(triggerId))
			this.triggerId=triggerId;
	}
	
	@Override
	public String toString() {
		return "function(){"+createFunction()+"}";
	}
	@Override
	public String getDisplayCaption() {
		return triggerId+"."+triggerEvent+"()";
	}
}
