package net.ko.mapping;

import java.util.ArrayList;

import net.ko.utils.KString;

import org.w3c.dom.Node;

public class KAjaxIncludeDialog extends KAjaxWithChilds implements IHasURL{
	protected KAjaxInclude include;
	protected KAjaxMessageDialog dialog;

	public KAjaxIncludeDialog() {
		super();
		include=new KAjaxInclude();
		dialog=new KAjaxMessageDialog();
	}

	@Override
	public String createFunction() {
		String begin="",end="";
		String parameters=include.createParameters();
		String func=include.getFunctions();
		if("".equals(func)){
			func="undefined";
		}
		if(dialog.getCondition()!=null&&!"".equals(dialog.getCondition())){
			begin="if("+dialog.getCondition()+"){";
			end="}";
		}
		String result=begin+"var lb=new Forms.AjaxLightBox('lb-inc-"+KString.cleanHTMLAttribute(dialog.getTitle())+"','"+KString.jsQuote(dialog.getTitle())+"','"+include.getTargetURL()+"',"+parameters+","+func+");";
		result+="lb.addActions("+dialog.getButtons()+");";
		result+="lb.modal="+dialog.isModal()+";";
		result+="lb."+include.getMethod().toLowerCase()+"();"+end;
		return result;
	}

	@Override
	public boolean isValid() {
		return include.getTargetURL()!=null && dialog.isValid();
	}

	@Override
	public void initFromXml(Node item) {
		Node n= getFirstNode(item,"include");
		if(n!=null)
			include.initFromXml(n);
		n=getFirstNode(item,"dialog");
		if(n!=null)
			dialog.initFromXml(n);
	}
	@Override
	public String toString() {
		String result=createFunction();
		if (isChild)
			result="function(obj){"+result+"}";
		return result;
	}

	@Override
	public String getURL() {
		return include.getURL();
	}

	@Override
	public String getDisplayCaption() {
		return include.getURL();
	}
	
	@Override
	public String getDisplayStructure() {
		String postFrm="";
		String getParams="()";
		String formName=include.getFormName();
		String targetParams=include.getTargetParams();
		if(formName!=null&&!"".equals(formName))
			postFrm="["+formName+"]";
		if(targetParams!=null&&!"".equals(targetParams))
			getParams="("+targetParams+")";
		return "<span class='title'>"+dialog.getTitle()+"</span> : <span class='url'>{caption}</span>-><span class='method'>"+include.getMethod()+postFrm+getParams+"</span>";
	}
	
	public ArrayList<IAjaxObject> getDialogChilds() {
		ArrayList<IAjaxObject> result=dialog.getChilds();
		return result;
	}
	
}
