package net.ko.mapping;

import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxMessage extends KAjaxObject {
	protected String targetId;
	protected String message;
	protected int timeout=-1;


	@Override
	public String createFunction() {
		String strTimeout="";
		message=replaceJsExpressions(message);
		if(timeout>1){
			strTimeout="setTimeout(function(){Forms.Utils.setWithReplacement(obj,$('"+targetId+"'),'');},"+timeout+");";
		}
		if(isChild)
			return "Forms.Utils.setWithReplacement(obj,$('"+targetId+"'),"+message+");"+strTimeout;
		else
			return "Forms.Utils.setWithReplacement(this,$('"+targetId+"'),"+message+");"+strTimeout;
	}

	public KAjaxMessage() {
		super();
	}

	@Override
	public boolean isValid() {
		return KString.isNotNull(targetId);
	}

	@Override
	public void initFromXml(Node item) {
		Element e=(Element)item;
		targetId=e.getAttribute("targetId");
		message=e.getTextContent();
		String strTimeout=e.getAttribute("timeout");
		try{
			timeout=Integer.valueOf(strTimeout);
		}catch(Exception ex){timeout=-1;}
	}
	
	@Override
	public String toString() {
		return "function(obj){"+createFunction()+"}";
	}

	@Override
	public String getDisplayCaption() {
		return targetId;
	}

	@Override
	public String getDisplayStructure() {
		return "<fieldset class='targetId'><legend>{caption}</legend><span title='"+KString.htmlSpecialChars(message)+"' class='message'>message</span></fieldset>";
	}
}
