package net.ko.mapping;

import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxMessageDialog extends KAjaxWithChilds {
	protected String title;
	protected String message="";
	protected String script="";
	protected String condition;
	protected boolean modal;

	public KAjaxMessageDialog() {
		super();
	}

	@Override
	public String createFunction() {
		String result="";
		String begin="",end="";
		if(condition!=null&&!"".equals(condition)){
			begin="if("+condition+"){";
			end="}";
		}
		result=begin+"var lb=new Forms.MessageDialog('lb-"+KString.cleanHTMLAttribute(title)+"','"+KString.jsQuote(title)+"','"+KString.jsQuote(message)+"',function(obj){"+script+"});";
		result+="lb.modal="+modal+";";
		result+="lb.addButtonsWF("+getButtons()+");";
		result+="lb.show();"+end;
		return result;
	}

	@Override
	public boolean isValid() {
		return true;
	}

	@Override
	public void initFromXml(Node item) {
		Element e=(Element)item;
		this.title=e.getAttribute("title");
		this.condition=e.getAttribute("condition");
		this.modal=KString.isBooleanTrue(e.getAttribute("modal"));
		Node n=getFirstNode(item, "message");
		if(n!=null){
			this.message=n.getTextContent();
			if(this.message!=null)
				this.message=this.message.replace("\n","");
		}
		childs=KAjaxJs.getChilds(item,false);
	}

	@Override
	public String toString() {
		String result=createFunction();
		if (isChild)
			result="function(obj){"+result+"}";
		return result;
	}
	public String getButtons(){
		String result="";
		for(int i=0;i<childs.size();i++){
			KAjaxDialogButton adb=(KAjaxDialogButton) childs.get(i);
			if("".equals(result))
				result+=adb.getButtons();
			else
				result+=","+adb.getButtons();
		}
		return "["+result+"]";
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public String getScript() {
		return script;
	}

	public void setScript(String script) {
		this.script = script;
	}

	public String getCondition() {
		return condition;
	}

	public void setCondition(String condition) {
		this.condition = condition;
	}

	public boolean isModal() {
		return modal;
	}

	public void setModal(boolean modal) {
		this.modal = modal;
	}

	@Override
	public String getDisplayCaption() {
		return title;
	}

}
