package net.ko.mapping;

import java.util.regex.Matcher;

import javax.servlet.http.HttpServletRequest;

import net.ko.utils.KHash;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public abstract class KAjaxObject implements IAjaxObject {
	protected boolean isChild;

	public KAjaxObject() {
		isChild=false;
	}

	public boolean isChild() {
		return isChild;
	}

	public void setChild(boolean isChild) {
		this.isChild = isChild;
	}
	public String execute(HttpServletRequest request){
		return toString();
	}
	public Node getFirstNode(Node item,String name){
		Node result=null;
		Element e=(Element)item;
		NodeList nList= e.getElementsByTagName(name);
		if(nList!=null)
			if(nList.getLength()>0)
				result=nList.item(0);
		return result;
	}
	
	@Override
	public String display(int margin){
		String structure=getDisplayStructure();
		structure=structure.replace("{caption}", getDisplayCaption());
		return "<div style='margin-left:"+(20*margin)+"px;' class='"+getClass().getSimpleName()+"'>"+structure+"</div>";
	}

	@Override
	public String getUniqueIdHash(int niveau) {
		return KHash.getMD5(niveau+getDisplayCaption());
	}

	@Override
	public String getDisplayStructure() {
		return "{caption}";
	}

	@Override
	public boolean hasChilds() {
		return false;
	}

	@Override
	public String replaceJsExpressions(String input) {
		String output=input;
		output=output.replaceAll("\\{js\\:(.*?)\\}", Matcher.quoteReplacement("'+")+"$1"+Matcher.quoteReplacement("+'"));
		output=output.replaceAll("\\{jsv\\:(.*?)\\}", Matcher.quoteReplacement("'+$$('")+"$1"+Matcher.quoteReplacement("')+'"));
		return output;
	}
	
}
