package net.ko.mapping;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.ko.utils.KHash;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class KAjaxRequest extends KAbstractFilterMapping {
	private ArrayList<IAjaxObject> ajaxIncludes;

	public KAjaxRequest(){
		this("");
	}
	public KAjaxRequest(String requestURL) {
		super(requestURL);
		ajaxIncludes=new ArrayList<>();
	}

	@Override
	public void initFromXml(Node item) {
		String requestURL=((Element)item).getAttribute("requestURL");
		if(requestURL!=null)
			this.requestURL=requestURL;
		NodeList paramsList=item.getChildNodes();
		for(int i=0;i<paramsList.getLength();i++){
			if(paramsList.item(i).getNodeName().equalsIgnoreCase("js")){
				Element e=(Element)paramsList.item(i);
				KAjaxJs ajaxJs=new KAjaxJs();
				ajaxJs.initFromXml(e);
				if (ajaxJs.isValid())
					ajaxIncludes.add(ajaxJs);
			}
		}
	}

	@Override
	public boolean matches(HttpServletRequest request) {
		return requestURLMatches(request);
	}

	@Override
	public boolean execute(HttpServletRequest request,HttpServletResponse response) {
		boolean result=false;
		out="";
		if(ajaxIncludes.size()>0){
			result=true;
			out="<script type='text/javascript'>\n";
			for(IAjaxObject ajaxInclude:ajaxIncludes){
				out+=ajaxInclude.execute(request)+"\n";
			}
			out+="</script>\n";
		}
		return result;
	}
	@Override
	public String toString() {
		return out;
	}
	public ArrayList<IAjaxObject> getAjaxIncludes() {
		return ajaxIncludes;
	}
	@Override
	public String display(int niveau) {
		String result= "<div style='margin-left:"+(20*niveau)+"px;' class='"+getClass().getSimpleName()+"'>"+requestURL+"</div>";
		return result;
	}
	public String getUniqueIdHash(int niveau) {
		return KHash.getMD5(niveau+requestURL);

	}
}
