package net.ko.mapping;

import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxSelector extends KAjaxWithChilds {
	private String containerId;
	private String tagName;
	private String className;
	private String elementName;
	private String selectedStyle;
	private String event;
	private boolean allowNull;
	private int startIndex;
	public KAjaxSelector() {
		super();
		tagName="";
		elementName="";
		selectedStyle="";
		event="click";
		allowNull=false;
		startIndex=1;
	}

	@Override
	public String createFunction() {
		String result="(new $selector($('"+containerId+"'),'"+event+"',"+allowNull;
		String functionStr=getFunctions();
		if(functionStr!=null&&!"".equals(functionStr))
			result+=","+functionStr;
		else
			result+=",undefined";
		if(selectedStyle!=null&&!"".equals(selectedStyle))
			result+=","+selectedStyle;
		result+="))";
		if(className!=null&&!"".equals(className))
			result+=".attachByClassName('"+className+"',"+startIndex+","+getTagName()+");";
		else if(tagName!=null&&!"".equals(tagName))
			result+=".attachByTagName('"+tagName+"',"+startIndex+");";
		else if(elementName!=null&&!"".equals(elementName))
			result+=".attachByName('"+elementName+"',"+startIndex+");";
		result=replaceJsExpressions(result);
		return result;
	}

	@Override
	public boolean isValid() {
		boolean result=true;
		result=result&&KString.isNotNull(containerId);
		result=result&&(KString.isNotNull(tagName)||KString.isNotNull(elementName)||KString.isNotNull(className));
		return result;
	}

	@Override
	public void initFromXml(Node item) {
		Element e=(Element)item;
		containerId=e.getAttribute("containerId");
		String tagName=e.getAttribute("tagName");
		if(tagName!=null)
			this.tagName=tagName;
		String className=e.getAttribute("className");
		if(className!=null)
			this.className=className;
		String elementName=e.getAttribute("elementName");
		if(elementName!=null)
			this.elementName=elementName;
		String selectedStyle=e.getAttribute("selectedStyle");
		if(selectedStyle!=null&&!"".equals(selectedStyle))
			this.selectedStyle=selectedStyle.replaceAll("\\s", "");
		String event=e.getAttribute("event");
		if(event!=null&&!"".equals(event))
			this.event=event;
		String targetFunction=e.getAttribute("targetFunction");
		if(targetFunction!=null&&!"".equals(targetFunction))
			this.targetFunction=targetFunction;
		allowNull=KString.isBooleanTrue(e.getAttribute("allowNull"));
		try{
			startIndex=Integer.valueOf(e.getAttribute("startIndex"));
		}
		catch(Exception ex){startIndex=1;}
		childs=KAjaxJs.getChilds(item,true);
	}

	@Override
	public String toString() {
		return "function(){"+createFunction()+"}";
	}

	public String getTagName() {
		if(KString.isNotNull(tagName))
			return "'"+tagName+"'";
		else
			return "undefined";
	}

	public void setTagName(String tagName) {
		this.tagName = tagName;
	}

	@Override
	public String getDisplayCaption() {
		return containerId+"["+tagName+className+"].on"+KString.capitalizeFirstLetter(event);
	}

	@Override
	public String getDisplayStructure() {
		return "{caption}";
	}
}
