package net.ko.mapping;

import net.ko.utils.KString;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class KAjaxShowHide extends KAjaxObject {
	private boolean visible;
	private String targetId;
	private String condition;
	
	@Override
	public String createFunction() {
		if(condition!=null&&!"".equals(condition))
			return "show('"+targetId+"',"+condition+");";
		else
			return "show('"+targetId+"',"+visible+");";
	}

	public KAjaxShowHide() {
		super();
		visible=false;
		condition="";
	}

	@Override
	public boolean isValid() {
		return KString.isNotNull("targetId");
	}

	@Override
	public void initFromXml(Node item) {
		Element e=(Element)item;
		targetId=e.getAttribute("targetId");
		condition=e.getAttribute("condition");
		visible=KString.isBooleanTrue(e.getAttribute("visible"));
	}
	
	@Override
	public String toString() {
		return "function(){"+createFunction()+"}";
	}

	@Override
	public String getDisplayCaption() {
		return targetId;
	}
}
